Index: trunk/demos/CircleFollower/simulator/build_core2_64/bin/simulator_x4.sh
===================================================================
--- trunk/demos/CircleFollower/simulator/build_core2_64/bin/simulator_x4.sh	(revision 282)
+++ trunk/demos/CircleFollower/simulator/build_core2_64/bin/simulator_x4.sh	(revision 286)
@@ -8,3 +8,3 @@
 . $FLAIR_ROOT/flair-dev/scripts/distribution_specific_hack.sh
 
-$EXEC -n x4_0 -t x4 -p 9000 -a 127.0.0.1 -x setup_x4.xml -o 100 -m $FLAIR_ROOT/flair-bin/models -s $FLAIR_ROOT/flair-bin/models/indoor_flight_arena.xml
+$EXEC -n x4_0 -t x4 -p 9000 -a 127.0.0.1 -x setup_x4.xml -o 10 -m $FLAIR_ROOT/flair-bin/models -s $FLAIR_ROOT/flair-bin/models/indoor_flight_arena.xml
Index: trunk/lib/FlairFilter/src/SimulatedAhrs.cpp
===================================================================
--- trunk/lib/FlairFilter/src/SimulatedAhrs.cpp	(revision 286)
+++ trunk/lib/FlairFilter/src/SimulatedAhrs.cpp	(revision 286)
@@ -0,0 +1,56 @@
+// %flair:license{
+// This file is part of the Flair framework distributed under the
+// CECILL-C License, Version 1.0.
+// %flair:license}
+//  created:    2014/02/07
+//  filename:   SimulatedAhrs.cpp
+//
+//  author:     Guillaume Sanahuja
+//              Copyright Heudiasyc UMR UTC/CNRS 7253
+//
+//  version:    $Id: $
+//
+//  purpose:    Class for a simulation ahrs
+//
+//
+/*********************************************************************/
+#ifdef CORE2_64
+
+#include "SimulatedAhrs.h"
+#include "SimulatedImu.h"
+#include <AhrsData.h>
+
+using std::string;
+using namespace flair::core;
+using namespace flair::sensor;
+
+namespace flair {
+namespace filter {
+
+SimulatedAhrs::SimulatedAhrs(string name, uint32_t modelId,uint32_t deviceId,
+                   uint8_t priority)
+    : Ahrs(new SimulatedImu("imu", modelId,deviceId, priority), name) {
+  SetIsReady(true);
+}
+
+SimulatedAhrs::~SimulatedAhrs() {}
+
+// datas from SimulatedImu are AhrsData!
+void SimulatedAhrs::UpdateFrom(const io_data *data) {
+  AhrsData *input = (AhrsData *)data;
+  AhrsData *output;
+  GetDatas(&output);
+
+  Quaternion quaternion;
+  Vector3Df filteredAngRates;
+  input->GetQuaternionAndAngularRates(quaternion, filteredAngRates);
+  output->SetQuaternionAndAngularRates(quaternion, filteredAngRates);
+  output->SetDataTime(input->DataTime());
+
+  ProcessUpdate(output);
+}
+
+} // end namespace filter
+} // end namespace flair
+
+#endif
Index: trunk/lib/FlairFilter/src/SimulatedAhrs.h
===================================================================
--- trunk/lib/FlairFilter/src/SimulatedAhrs.h	(revision 286)
+++ trunk/lib/FlairFilter/src/SimulatedAhrs.h	(revision 286)
@@ -0,0 +1,60 @@
+// %flair:license{
+// This file is part of the Flair framework distributed under the
+// CECILL-C License, Version 1.0.
+// %flair:license}
+/*!
+ * \file SimulatedAhrs.h
+ * \brief Class for a simulation Ahrs
+ * \author Guillaume Sanahuja, Copyright Heudiasyc UMR UTC/CNRS 7253
+ * \date 2014/02/07
+ * \version 4.0
+ */
+
+#ifndef SIMUAHRS_H
+#define SIMUAHRS_H
+
+#include <Ahrs.h>
+#include <stdint.h>
+
+namespace flair {
+namespace filter {
+/*! \class SimulatedAhrs
+*
+* \brief Class for a simulation Ahrs
+*
+* This class constructs a SimulatedImu as Imu of this Ahrs.
+*/
+class SimulatedAhrs : public filter::Ahrs {
+public:
+  /*!
+  * \brief Constructor
+  *
+  * Construct a simulation Ahrs. It will be child of the FrameworkManager.
+  *
+  * \param name name
+  * \param modelId Model id
+  * \param deviceId Ahrs id of the Model
+  * \param priority priority of the SimulatedImu Thread
+  */
+  SimulatedAhrs(std::string name,
+           uint32_t modelId,uint32_t deviceId, uint8_t priority);
+
+  /*!
+  * \brief Destructor
+  *
+  */
+  ~SimulatedAhrs();
+
+private:
+  /*!
+  * \brief Update using provided datas
+  *
+  * Reimplemented from IODevice.
+  *
+  * \param data data from the parent to process
+  */
+  void UpdateFrom(const core::io_data *data);
+};
+} // end namespace filter
+} // end namespace flair
+#endif // SIMUAHRS_H
Index: trunk/lib/FlairMeta/src/MetaVrpnObject.cpp
===================================================================
--- trunk/lib/FlairMeta/src/MetaVrpnObject.cpp	(revision 282)
+++ trunk/lib/FlairMeta/src/MetaVrpnObject.cpp	(revision 286)
@@ -18,5 +18,4 @@
 
 #include "MetaVrpnObject.h"
-#include "VrpnClient.h"
 #include <EulerDerivative.h>
 #include <LowPassFilter.h>
@@ -38,16 +37,15 @@
 namespace meta {
 
-MetaVrpnObject::MetaVrpnObject(string name)
-    : VrpnObject( name, GetVrpnClient()->GetTabWidget()) {
-  ConstructorCommon(name);
+MetaVrpnObject::MetaVrpnObject(string name,VrpnClient *client)
+    : VrpnObject( name, client->GetTabWidget(),client) {
+  ConstructorCommon(name,client);
 }
 
-MetaVrpnObject::MetaVrpnObject(std::string name,
-                               uint8_t id)
-    : VrpnObject(name, id, GetVrpnClient()->GetTabWidget()) {
-  ConstructorCommon( name);
+MetaVrpnObject::MetaVrpnObject(std::string name,uint8_t id,VrpnClient *client)
+    : VrpnObject(name, id, client->GetTabWidget(),client) {
+  ConstructorCommon( name,client);
 }
 
-void MetaVrpnObject::ConstructorCommon(string name) {
+void MetaVrpnObject::ConstructorCommon(string name,VrpnClient *client) {
   cvmatrix_descriptor *desc = new cvmatrix_descriptor(7, 1);
   for (int i = 0; i < desc->Rows(); i++) {
@@ -57,5 +55,5 @@
   delete desc;
 
-  pbas = new LowPassFilter(this, GetVrpnClient()->GetLayout()->NewRow(),
+  pbas = new LowPassFilter(this, client->GetLayout()->NewRow(),
                            name + " Passe bas", prev_value);
   delete prev_value;
@@ -68,5 +66,5 @@
   delete desc;
 
-  euler = new EulerDerivative(pbas, GetVrpnClient()->GetLayout()->NewRow(),
+  euler = new EulerDerivative(pbas, client->GetLayout()->NewRow(),
                               name + "_euler", prev_value);
   delete prev_value;
@@ -79,5 +77,5 @@
   vz_opti_plot->AddCurve(euler->GetMatrix()->Element(6));
 
-  plot_tab = new Tab(GetVrpnClient()->GetTabWidget(), "Mesures (xy) " + name);
+  plot_tab = new Tab(client->GetTabWidget(), "Mesures (xy) " + name);
   xy_plot = new DataPlot2D(plot_tab->NewRow(), "xy", "y", -5, 5, "x", -5, 5);
   xy_plot->AddCurve(Output()->Element(5, 0), Output()->Element(4, 0));
Index: trunk/lib/FlairMeta/src/MetaVrpnObject.h
===================================================================
--- trunk/lib/FlairMeta/src/MetaVrpnObject.h	(revision 282)
+++ trunk/lib/FlairMeta/src/MetaVrpnObject.h	(revision 286)
@@ -15,4 +15,5 @@
 
 #include <VrpnObject.h>
+#include <VrpnClient.h>
 #include <io_data.h>
 #include <Vector3D.h>
@@ -41,6 +42,6 @@
 class MetaVrpnObject : public sensor::VrpnObject {
 public:
-  MetaVrpnObject(std::string name);
-  MetaVrpnObject(std::string name,uint8_t id);
+  MetaVrpnObject(std::string name,sensor::VrpnClient *client=sensor::GetVrpnClient());
+  MetaVrpnObject(std::string name,uint8_t id,sensor::VrpnClient *client=sensor::GetVrpnClient());
   ~MetaVrpnObject();
   gui::DataPlot1D *VxPlot(void) const; // 1,0
@@ -51,5 +52,5 @@
 
 private:
-  void ConstructorCommon(std::string name);
+  void ConstructorCommon(std::string name,sensor::VrpnClient *client);
   filter::LowPassFilter *pbas;
   filter::EulerDerivative *euler;
Index: trunk/lib/FlairMeta/src/SimuX4.cpp
===================================================================
--- trunk/lib/FlairMeta/src/SimuX4.cpp	(revision 282)
+++ trunk/lib/FlairMeta/src/SimuX4.cpp	(revision 286)
@@ -20,12 +20,12 @@
 #include <FrameworkManager.h>
 #include <X4X8Multiplex.h>
-#include <SimuImu.h>
-#include <SimuAhrs.h>
-#include <SimuBldc.h>
-#include <SimuUs.h>
-#include <SimuCamera.h>
-#include <SimuPressureSensor.h>
+#include <SimulatedImu.h>
+#include <SimulatedAhrs.h>
+#include <SimulatedBldc.h>
+#include <SimulatedUs.h>
+#include <SimulatedCamera.h>
+#include <SimulatedPressureSensor.h>
 #include <BatteryMonitor.h>
-#include <SimuGps.h>
+#include <SimulatedGps.h>
 #include <Tab.h>
 #include <FindArgument.h>
@@ -48,8 +48,8 @@
     SetMultiplex(new X4X8Multiplex("motors", X4X8Multiplex::X4));
 
-  SetBldc(new SimuBldc(GetUavMultiplex(), GetUavMultiplex()->GetLayout(),
+  SetBldc(new SimulatedBldc(GetUavMultiplex(), GetUavMultiplex()->GetLayout(),
                        "motors", GetUavMultiplex()->MotorsCount(), simu_id,0));
-  SetUsRangeFinder(new SimuUs("us", simu_id,0, 60));
-  SetAhrs(new SimuAhrs("ahrs", simu_id, 0,70));
+  SetUsRangeFinder(new SimulatedUs("us", simu_id,0, 60));
+  SetAhrs(new SimulatedAhrs("ahrs", simu_id, 0,70));
   Tab *bat_tab = new Tab(getFrameworkManager()->GetTabWidget(), "battery");
   SetBatteryMonitor(new BatteryMonitor(bat_tab->NewRow(), "battery"));
@@ -59,19 +59,19 @@
 	ReadCameraResolutionOption(options,"camv",camvWidth,camvHeight);
   Info("using vertical camera resolution: %ix%i\n",camvWidth, camvHeight);
-  SetVerticalCamera(new SimuCamera("simu_cam_v", camvWidth, camvHeight, 3, simu_id,0, 10));
+  SetVerticalCamera(new SimulatedCamera("simu_cam_v", camvWidth, camvHeight, 3, simu_id,0, 10));
   
   uint16_t camhWidth=320,camhHeight=240;
   ReadCameraResolutionOption(options,"camh",camhWidth,camhHeight);
   Info("using horizontal camera resolution: %ix%i\n",camhWidth, camhHeight);
-  SetHorizontalCamera(new SimuCamera("simu_cam_h", camhWidth, camhHeight, 3, simu_id,1, 10));
+  SetHorizontalCamera(new SimulatedCamera("simu_cam_h", camhWidth, camhHeight, 3, simu_id,1, 10));
   
   string useGps=FindArgument(options,"use_gps=",false);
   if(useGps=="true") {
-    SetGps(new SimuGps("gps", (NmeaGps::NMEAFlags_t)(NmeaGps::GGA | NmeaGps::VTG), 0,0, 40));
+    SetGps(new SimulatedGps("gps", (NmeaGps::NMEAFlags_t)(NmeaGps::GGA | NmeaGps::VTG), 0,0, 40));
   }
   
   string usePressureSensor=FindArgument(options,"use_pressure_sensor=",false);
   if(usePressureSensor=="true") {
-    SetPressureSensor(new SimuPressureSensor("pressuresensor", 0,0, 10));
+    SetPressureSensor(new SimulatedPressureSensor("pressuresensor", 0,0, 10));
   } 
 }
@@ -80,10 +80,10 @@
 
 void SimuX4::StartSensors(void) {
-  ((SimuImu *)(GetAhrs()->GetImu()))->Start();
-  ((SimuUs *)GetUsRangeFinder())->Start();
-  ((SimuCamera *)GetVerticalCamera())->Start();
-  ((SimuCamera *)GetHorizontalCamera())->Start();
-  if(GetGps()) ((SimuGps *)GetGps())->Start();
-  if(GetPressureSensor()) ((SimuPressureSensor *)GetPressureSensor())->Start();
+  ((SimulatedImu *)(GetAhrs()->GetImu()))->Start();
+  ((SimulatedUs *)GetUsRangeFinder())->Start();
+  ((SimulatedCamera *)GetVerticalCamera())->Start();
+  ((SimulatedCamera *)GetHorizontalCamera())->Start();
+  if(GetGps()) ((SimulatedGps *)GetGps())->Start();
+  if(GetPressureSensor()) ((SimulatedPressureSensor *)GetPressureSensor())->Start();
 }
 
Index: trunk/lib/FlairMeta/src/SimuX8.cpp
===================================================================
--- trunk/lib/FlairMeta/src/SimuX8.cpp	(revision 282)
+++ trunk/lib/FlairMeta/src/SimuX8.cpp	(revision 286)
@@ -20,12 +20,12 @@
 #include <FrameworkManager.h>
 #include <X4X8Multiplex.h>
-#include <SimuImu.h>
-#include <SimuAhrs.h>
-#include <SimuBldc.h>
-#include <SimuUs.h>
-#include <SimuCamera.h>
-#include <SimuPressureSensor.h>
+#include <SimulatedImu.h>
+#include <SimulatedAhrs.h>
+#include <SimulatedBldc.h>
+#include <SimulatedUs.h>
+#include <SimulatedCamera.h>
+#include <SimulatedPressureSensor.h>
 #include <BatteryMonitor.h>
-#include <SimuGps.h>
+#include <SimulatedGps.h>
 #include <Tab.h>
 #include <FindArgument.h>
@@ -48,8 +48,8 @@
     SetMultiplex(new X4X8Multiplex("motors", X4X8Multiplex::X8));
 
-  SetBldc(new SimuBldc(GetUavMultiplex(), GetUavMultiplex()->GetLayout(),
+  SetBldc(new SimulatedBldc(GetUavMultiplex(), GetUavMultiplex()->GetLayout(),
                        "motors", GetUavMultiplex()->MotorsCount(), simu_id,0));
-  SetUsRangeFinder(new SimuUs("us", simu_id,0, 60));
-  SetAhrs(new SimuAhrs("ahrs", simu_id, 0,70));
+  SetUsRangeFinder(new SimulatedUs("us", simu_id,0, 60));
+  SetAhrs(new SimulatedAhrs("ahrs", simu_id, 0,70));
   Tab *bat_tab = new Tab(getFrameworkManager()->GetTabWidget(), "battery");
   SetBatteryMonitor(new BatteryMonitor(bat_tab->NewRow(), "battery"));
@@ -59,19 +59,19 @@
 	ReadCameraResolutionOption(options,"camv",camvWidth,camvHeight);
   Info("using vertical camera resolution: %ix%i\n",camvWidth, camvHeight);
-  SetVerticalCamera(new SimuCamera("simu_cam_v", camvWidth, camvHeight, 3, simu_id,0, 10));
+  SetVerticalCamera(new SimulatedCamera("simu_cam_v", camvWidth, camvHeight, 3, simu_id,0, 10));
   
   uint16_t camhWidth=320,camhHeight=240;
   ReadCameraResolutionOption(options,"camh",camhWidth,camhHeight);
   Info("using horizontal camera resolution: %ix%i\n",camhWidth, camhHeight);
-  SetHorizontalCamera(new SimuCamera("simu_cam_h", camhWidth, camhHeight, 3, simu_id,1, 10));
+  SetHorizontalCamera(new SimulatedCamera("simu_cam_h", camhWidth, camhHeight, 3, simu_id,1, 10));
   
   string useGps=FindArgument(options,"use_gps=",false);
   if(useGps=="true") {
-    SetGps(new SimuGps("gps", (NmeaGps::NMEAFlags_t)(NmeaGps::GGA | NmeaGps::VTG), 0,0, 40));
+    SetGps(new SimulatedGps("gps", (NmeaGps::NMEAFlags_t)(NmeaGps::GGA | NmeaGps::VTG), 0,0, 40));
   } 
   
   string usePressureSensor=FindArgument(options,"use_pressure_sensor=",false);
   if(usePressureSensor=="true") {
-    SetPressureSensor(new SimuPressureSensor("pressuresensor", 0,0, 10));
+    SetPressureSensor(new SimulatedPressureSensor("pressuresensor", 0,0, 10));
   } 
 }
@@ -80,10 +80,10 @@
 
 void SimuX8::StartSensors(void) {
-  ((SimuImu *)(GetAhrs()->GetImu()))->Start();
-  ((SimuUs *)GetUsRangeFinder())->Start();
-  ((SimuCamera *)GetVerticalCamera())->Start();
-  ((SimuCamera *)GetHorizontalCamera())->Start();
-  if(GetGps()) ((SimuGps *)GetGps())->Start();
-  if(GetPressureSensor()) ((SimuPressureSensor *)GetPressureSensor())->Start();
+  ((SimulatedImu *)(GetAhrs()->GetImu()))->Start();
+  ((SimulatedUs *)GetUsRangeFinder())->Start();
+  ((SimulatedCamera *)GetVerticalCamera())->Start();
+  ((SimulatedCamera *)GetHorizontalCamera())->Start();
+  if(GetGps()) ((SimulatedGps *)GetGps())->Start();
+  if(GetPressureSensor()) ((SimulatedPressureSensor *)GetPressureSensor())->Start();
 }
 
Index: trunk/lib/FlairSensorActuator/src/SimulatedBldc.cpp
===================================================================
--- trunk/lib/FlairSensorActuator/src/SimulatedBldc.cpp	(revision 286)
+++ trunk/lib/FlairSensorActuator/src/SimulatedBldc.cpp	(revision 286)
@@ -0,0 +1,83 @@
+// %flair:license{
+// This file is part of the Flair framework distributed under the
+// CECILL-C License, Version 1.0.
+// %flair:license}
+//  created:    2014/02/07
+//  filename:   SimulatedBldc.cpp
+//
+//  author:     Guillaume Sanahuja
+//              Copyright Heudiasyc UMR UTC/CNRS 7253
+//
+//  version:    $Id: $
+//
+//  purpose:    Class for a simulation bldc
+//
+//
+/*********************************************************************/
+#ifdef CORE2_64
+
+#include "SimulatedBldc.h"
+#include <FrameworkManager.h>
+#include <GridLayout.h>
+#include <DoubleSpinBox.h>
+#include <GroupBox.h>
+#include <SharedMem.h>
+#include <Matrix.h>
+#include <sstream>
+#include <string.h>
+
+using std::string;
+using std::ostringstream;
+using namespace flair::core;
+using namespace flair::gui;
+
+namespace flair {
+namespace actuator {
+
+SimulatedBldc::SimulatedBldc(const IODevice *parent, Layout *layout, string name,
+                   uint8_t motors_count, uint32_t modelId,uint32_t deviceId)
+    : Bldc(parent, layout, name, motors_count) {
+  shmem =
+      new SharedMem(this, ShMemName(modelId, deviceId), motors_count * sizeof(float)+sizeof(Time));
+
+  GroupBox *groupbox = new GroupBox(layout->NewRow(), "simubldc");
+  k = new DoubleSpinBox(groupbox->NewRow(), "k driver:", 0, 10000, 1);
+  
+  buf=(char*)malloc(motors_count * sizeof(float)+sizeof(Time));
+  if(buf==NULL) {
+    Err("error creating buffer\n");
+    return;
+  }
+  SetIsReady(true);
+}
+
+SimulatedBldc::~SimulatedBldc() {
+  if(buf!=NULL) free(buf);
+}
+
+string SimulatedBldc::ShMemName(uint32_t modelId,uint32_t deviceId) {
+  ostringstream dev_name;
+  dev_name << "simu" <<  modelId << "_bldc_" << deviceId;
+  return dev_name.str().c_str();
+}
+
+void SimulatedBldc::SetMotors(float *value) {
+  float *values=(float*)buf;
+  for (int i = 0; i < MotorsCount(); i++) values[i] = k->Value() * value[i];
+  Time time=GetTime();
+  memcpy(buf+MotorsCount() * sizeof(float),&time,sizeof(Time));
+
+  shmem->Write(buf, MotorsCount() * sizeof(float)+sizeof(Time));
+
+  // on prend une fois pour toute le mutex et on fait des accès directs
+  output->GetMutex();
+  for (int i = 0; i < MotorsCount(); i++) {
+    output->SetValueNoMutex(i, 0, values[i]);
+  }
+  output->ReleaseMutex();
+}
+
+} // end namespace sensor
+} // end namespace flair
+
+#endif
Index: trunk/lib/FlairSensorActuator/src/SimulatedBldc.h
===================================================================
--- trunk/lib/FlairSensorActuator/src/SimulatedBldc.h	(revision 286)
+++ trunk/lib/FlairSensorActuator/src/SimulatedBldc.h	(revision 286)
@@ -0,0 +1,97 @@
+// %flair:license{
+// This file is part of the Flair framework distributed under the
+// CECILL-C License, Version 1.0.
+// %flair:license}
+/*!
+ * \file SimulatedBldc.h
+ * \brief Class for a simulation bldc
+ * \author Guillaume Sanahuja, Copyright Heudiasyc UMR UTC/CNRS 7253
+ * \date 2014/02/07
+ * \version 4.0
+ */
+
+#ifndef SIMULATEDBLDC_H
+#define SIMULATEDBLDC_H
+
+#include <Bldc.h>
+
+namespace flair {
+namespace core {
+class SharedMem;
+class IODevice;
+class Matrix;
+}
+namespace gui {
+class DoubleSpinBox;
+class Layout;
+}
+}
+
+namespace flair {
+namespace actuator {
+/*! \class SimulatedBldc
+*
+* \brief Class for a simulation bldc
+*
+*/
+class SimulatedBldc : public Bldc {
+public:
+  /*!
+  * \brief Constructor
+  *
+  * Construct a SimulatedBldc
+  *
+  * \param parent parent
+  * \param layout layout
+  * \param name name
+  * \param motors_count number of motors
+  * \param modelId Model id
+  * \param deviceId Bldc id of the Model
+  */
+  SimulatedBldc(const core::IODevice *parent, gui::Layout *layout, std::string name,
+           uint8_t motors_count, uint32_t modelId,uint32_t deviceId);
+
+  /*!
+  * \brief Destructor
+  *
+  */
+  ~SimulatedBldc();
+
+  /*!
+  * \brief Has speed measurement
+  *
+  * Reimplemented from Bldc. \n
+  *
+  * \return true if it has speed measurement
+  */
+  bool HasSpeedMeasurement(void) const { return false; };
+
+  /*!
+  * \brief Has current measurement
+  *
+  * Reimplemented from Bldc. \n
+  *
+  * \return true if it has current measurement
+  */
+  bool HasCurrentMeasurement(void) const { return false; };
+
+private:
+  /*!
+  * \brief Set motors values
+  *
+  * Reimplemented from Bldc. \n
+  * Values size must be the same as MotorsCount()
+  *
+  * \param values motor values
+  */
+  void SetMotors(float *value);
+  
+  std::string ShMemName(uint32_t modelId,uint32_t deviceId);
+  core::SharedMem *shmem;
+  gui::DoubleSpinBox *k;
+  char *buf;
+
+};
+} // end namespace actuator
+} // end namespace flair
+#endif // SIMULATEDBLDC_H
Index: trunk/lib/FlairSensorActuator/src/SimulatedCamera.cpp
===================================================================
--- trunk/lib/FlairSensorActuator/src/SimulatedCamera.cpp	(revision 286)
+++ trunk/lib/FlairSensorActuator/src/SimulatedCamera.cpp	(revision 286)
@@ -0,0 +1,96 @@
+// %flair:license{
+// This file is part of the Flair framework distributed under the
+// CECILL-C License, Version 1.0.
+// %flair:license}
+//  created:    2014/03/06
+//  filename:   SimulatedCamera.cpp
+//
+//  author:     Guillaume Sanahuja
+//              Copyright Heudiasyc UMR UTC/CNRS 7253
+//
+//  version:    $Id: $
+//
+//  purpose:    Class for a simulation camera
+//
+//
+/*********************************************************************/
+#ifdef CORE2_64
+
+#include "SimulatedCamera.h"
+#include <FrameworkManager.h>
+#include <GroupBox.h>
+#include <SharedMem.h>
+#include <sstream>
+
+using std::string;
+using std::ostringstream;
+using namespace flair::core;
+using namespace flair::gui;
+
+namespace flair {
+namespace sensor {
+
+SimulatedCamera::SimulatedCamera(string name,
+                       uint16_t width, uint16_t height, uint8_t channels,
+                       uint32_t modelId,uint32_t deviceId, uint8_t priority)
+    : Thread(getFrameworkManager(), name, priority),
+      Camera(name, width, height, cvimage::Type::Format::BGR) {
+
+  buf_size = width * height * channels+sizeof(Time);
+
+  shmemReadBuf=(char*)malloc(buf_size);
+  output->img->imageData = shmemReadBuf;
+
+  shmem = new SharedMem((Thread *)this,ShMemName(modelId, deviceId), buf_size, SharedMem::Type::producerConsumer);
+  
+  SetIsReady(true);
+}
+
+
+SimulatedCamera::~SimulatedCamera() {
+  SafeStop();
+  Join();
+  if(shmemReadBuf!=NULL) delete shmemReadBuf;
+}
+
+string SimulatedCamera::ShMemName(uint32_t modelId,uint32_t deviceId) {
+  ostringstream dev_name;
+  dev_name << "simu" <<  modelId << "_cam_" << deviceId;
+  return dev_name.str().c_str();
+}
+
+void SimulatedCamera::Run(void) {
+  Time time;
+
+//  SetPeriodUS((uint32_t)(1000000. / data_rate->Value()));
+  shmem->ReaderReady();
+
+  while (!ToBeStopped()) {
+//    WaitPeriod();
+
+//    if (data_rate->ValueChanged() == true) {
+//      SetPeriodUS((uint32_t)(1000000. / data_rate->Value()));
+//    }
+
+    output->GetMutex();
+    //blocking read
+    if (shmem->Read(shmemReadBuf, buf_size, 1000000000)) { // remplacer copie par
+      // échange de pointeur sur
+      // double buffering
+
+      output->ReleaseMutex();
+      memcpy(&time, shmemReadBuf + buf_size - sizeof(Time), sizeof(Time));
+      output->SetDataTime(time);
+
+      ProcessUpdate(output);
+    } else {
+      output->ReleaseMutex();
+      //Thread::Warn("Read Timeout\n");
+    }
+  }
+}
+
+} // end namespace sensor
+} // end namespace flair
+
+#endif
Index: trunk/lib/FlairSensorActuator/src/SimulatedCamera.h
===================================================================
--- trunk/lib/FlairSensorActuator/src/SimulatedCamera.h	(revision 286)
+++ trunk/lib/FlairSensorActuator/src/SimulatedCamera.h	(revision 286)
@@ -0,0 +1,91 @@
+// %flair:license{
+// This file is part of the Flair framework distributed under the
+// CECILL-C License, Version 1.0.
+// %flair:license}
+/*!
+ * \file SimulatedCamera.h
+ * \brief Class for a simulation camera
+ * \author Guillaume Sanahuja, Copyright Heudiasyc UMR UTC/CNRS 7253
+ * \date 2014/03/06
+ * \version 4.0
+ */
+
+#ifndef SIMULATEDCAMERA_H
+#define SIMULATEDCAMERA_H
+
+#include <Camera.h>
+#include <Thread.h>
+#include <cxcore.h>
+
+namespace flair {
+  namespace core {
+    class SharedMem;
+  }
+}
+
+namespace flair {
+namespace sensor {
+/*! \class SimulatedCamera
+*
+* \brief Class for a simulation camera
+*/
+class SimulatedCamera : public core::Thread, public Camera {
+public:
+  /*!
+  * \brief Constructor
+  *
+  * Construct a SimulatedCamera.
+	* It will be child of the FrameworkManager.
+  *
+  * \param name name
+  * \param width width
+  * \param height height
+  * \param channels number of channels
+  * \param modelId Model id
+  * \param deviceId Camera id of the Model
+  * \param priority priority of the Thread
+  */
+  SimulatedCamera(std::string name,
+             uint16_t width, uint16_t height, uint8_t channels, uint32_t modelId,uint32_t deviceId,
+             uint8_t priority);
+
+
+  /*!
+  * \brief Destructor
+  *
+  */
+  ~SimulatedCamera();
+
+protected:
+  /*!
+  * \brief SharedMem to access datas
+  *
+  */
+  core::SharedMem *shmem;
+
+private:
+  /*!
+  * \brief Run function
+  *
+  * Reimplemented from Thread.
+  *
+  */
+  void Run(void);
+
+  /*!
+  * \brief Update using provided datas
+  *
+  * Reimplemented from IODevice.
+  *
+  * \param data data from the parent to process
+  */
+  void UpdateFrom(const core::io_data *data){};
+  
+  std::string ShMemName(uint32_t modelId,uint32_t deviceId);
+
+  size_t buf_size;
+  char* shmemReadBuf;
+};
+} // end namespace sensor
+} // end namespace flair
+#endif // SIMULATEDCAMERA_H
Index: trunk/lib/FlairSensorActuator/src/SimulatedGps.cpp
===================================================================
--- trunk/lib/FlairSensorActuator/src/SimulatedGps.cpp	(revision 286)
+++ trunk/lib/FlairSensorActuator/src/SimulatedGps.cpp	(revision 286)
@@ -0,0 +1,137 @@
+// %flair:license{
+// This file is part of the Flair framework distributed under the
+// CECILL-C License, Version 1.0.
+// %flair:license}
+//  created:    2014/05/26
+//  filename:   SimulatedGps.cpp
+//
+//  author:     Guillaume Sanahuja
+//              Copyright Heudiasyc UMR UTC/CNRS 7253
+//
+//  version:    $Id: $
+//
+//  purpose:    Class for a simulation GPS
+//
+//
+/*********************************************************************/
+#ifdef CORE2_64
+
+#include "SimulatedGps.h"
+#include <FrameworkManager.h>
+#include <GpsData.h>
+#include <SharedMem.h>
+#include <SpinBox.h>
+#include <DoubleSpinBox.h>
+#include <GroupBox.h>
+#include <Euler.h>
+#include <Matrix.h>
+#include <sstream>
+#include "geodesie.h"
+
+using std::string;
+using std::ostringstream;
+using namespace flair::core;
+using namespace flair::gui;
+using namespace Geodesie;
+
+namespace flair {
+namespace sensor {
+
+SimulatedGps::SimulatedGps(string name,
+                 NmeaGps::NMEAFlags_t NMEAFlags, uint32_t modelId,uint32_t deviceId,uint8_t priority)
+    : NmeaGps(name, NMEAFlags),Thread(getFrameworkManager(), name, priority) {
+
+  dataRate = new SpinBox(GetGroupBox()->NewRow(), "data rate", " Hz", 1, 500, 1, 200);
+  latitudeRef = new DoubleSpinBox(GetGroupBox()->NewRow(), "latitude ref", " deg", -90, 90, 1, 6,49.402313);
+  longitudeRef = new DoubleSpinBox(GetGroupBox()->LastRowLastCol(), "longitude ref", " deg", -180, 180, 1, 6,2.795463);
+  altitudeRef= new DoubleSpinBox(GetGroupBox()->LastRowLastCol(), "altitude ref", " m", 0, 6000, 100, 1,0);
+  fixQuality = new SpinBox(GetGroupBox()->NewRow(), "fix quality", 1, 8, 1, 1);
+  numberOfSatellites = new SpinBox(GetGroupBox()->NewRow(), "number of satellites", 1, 15, 1, 5);
+  magneticDeclination= new DoubleSpinBox(GetGroupBox()->NewRow(), "magnetic declination", " deg", -180, 180, .1, 2,0);
+  
+  shmem = new SharedMem((Thread *)this, ShMemName(modelId, deviceId),
+                        sizeof(gps_states_t));
+                        
+  SetIsReady(true);
+}
+
+
+SimulatedGps::~SimulatedGps() {
+  SafeStop();
+  Join();
+}
+
+string SimulatedGps::ShMemName(uint32_t modelId,uint32_t deviceId) {
+  ostringstream dev_name;
+  dev_name << "simu" <<  modelId << "_gps_" << deviceId;
+  return dev_name.str().c_str();
+}
+
+void SimulatedGps::Run(void) {
+  gps_states_t state;
+  char buf[512];
+  nmeaGPGGA gga;
+  nmeaGPVTG vtg;
+  nmeaPOS pos;
+  nmeaINFO info;
+
+  vtg.dir_t='T';
+  vtg.dec_m='M';
+  vtg.spk_k='K';
+  vtg.spn_n='N';
+  gga.elv_units='M';
+  gga.diff_units='M';
+
+  SetPeriodUS((uint32_t)(1000000. / dataRate->Value()));
+
+  WarnUponSwitches(true);
+
+
+  while (!ToBeStopped()) {
+    WaitPeriod();
+
+    if (dataRate->ValueChanged() == true) {
+      SetPeriodUS((uint32_t)(1000000. / dataRate->Value()));
+    }
+
+    shmem->Read((char *)&state, sizeof(gps_states_t));
+
+    double x, y, z;
+    ENU_2_ECEF(state.e, state.n, state.u, x,y,z, Euler::ToRadian(longitudeRef->Value()), Euler::ToRadian(latitudeRef->Value()), altitudeRef->Value());
+    ECEF_2_Geographique( x, y, z,pos.lon, pos.lat, gga.elv);
+    nmea_pos2info(&pos,&info);
+
+    if(pos.lat>0) {
+      gga.ns='N';
+      gga.lat=info.lat;
+    } else {
+      gga.ns='S';
+      gga.lat=-info.lat;
+    }
+    if(pos.lon>0) {
+      gga.ew='E';
+      gga.lon=info.lon;
+    } else {
+      gga.ew='W';
+      gga.lon=-info.lon;
+    }
+
+    gga.sig=fixQuality->Value();
+    gga.satinuse=numberOfSatellites->Value();
+
+    int size=nmea_gen_GPGGA(buf,sizeof(buf),&gga);
+    parseFrame(buf,size);
+    
+    vtg.dir=90-Euler::ToDegree(atan2f(state.vn,state.ve));
+    vtg.spk=sqrtf(state.ve*state.ve+state.vn*state.vn)*3600./1000.;
+    size=nmea_gen_GPVTG(buf,sizeof(buf),&vtg);
+    parseFrame(buf,size);
+  }
+
+  WarnUponSwitches(false);
+}
+
+} // end namespace sensor
+} // end namespace flair
+
+#endif
Index: trunk/lib/FlairSensorActuator/src/SimulatedGps.h
===================================================================
--- trunk/lib/FlairSensorActuator/src/SimulatedGps.h	(revision 286)
+++ trunk/lib/FlairSensorActuator/src/SimulatedGps.h	(revision 286)
@@ -0,0 +1,92 @@
+// %flair:license{
+// This file is part of the Flair framework distributed under the
+// CECILL-C License, Version 1.0.
+// %flair:license}
+/*!
+ * \file SimulatedGps.h
+ * \brief Class for a simulation GPS
+ * \author Guillaume Sanahuja, Copyright Heudiasyc UMR UTC/CNRS 7253
+ * \date 2013/08/23
+ * \version 4.0
+ */
+
+#ifndef SimulatedGPS_H
+#define SimulatedGPS_H
+
+#include <Thread.h>
+#include <NmeaGps.h>
+
+namespace flair {
+  namespace core {
+    class SharedMem;
+  }
+  namespace gui {
+    class SpinBox;
+    class DoubleSpinBox;
+  }
+}
+
+namespace flair {
+namespace sensor {
+/*! \class SimulatedGps
+*
+* \brief Class for a simulation GPS
+*/
+class SimulatedGps : public core::Thread, public NmeaGps {
+public:
+  /*!
+  * \brief Constructor
+  *
+  * Construct a simulation GPS
+  * It will be child of the FrameworkManager.
+	* 
+  * \param name name
+  * \param NMEAFlags NMEA sentances to enable
+  * \param modelId Model id
+  * \param deviceId Gps id of the Model
+  * \param priority priority of the Thread
+  */
+  SimulatedGps(std::string name,
+          NmeaGps::NMEAFlags_t NMEAFlags, uint32_t modelId,uint32_t deviceId,uint8_t priority);
+
+  /*!
+  * \brief Destructor
+  *
+  */
+  ~SimulatedGps();
+
+private:
+  /*!
+  * \brief Update using provided datas
+  *
+  * Reimplemented from IODevice.
+  *
+  * \param data data from the parent to process
+  */
+  void UpdateFrom(const core::io_data *data){};
+
+  /*!
+  * \brief Run function
+  *
+  * Reimplemented from Thread.
+  *
+  */
+  void Run(void);
+
+  typedef struct {
+    float e;
+    float n;
+    float u;
+    float ve;
+    float vn;
+  } gps_states_t;
+  
+  std::string ShMemName(uint32_t modelId,uint32_t deviceId);
+
+  core::SharedMem *shmem;
+  gui::SpinBox *dataRate,*fixQuality,*numberOfSatellites;
+  gui::DoubleSpinBox *latitudeRef,*longitudeRef,*altitudeRef,*magneticDeclination;
+};
+} // end namespace sensor
+} // end namespace flair
+#endif // SIMULATEDGPS_H
